-- U:\RISC_CORE_I\CPU_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Thu Sep 27 20:35:33 2001

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT CPU
		PORT (
			clock : in  std_logic;
			opc_clk : out  std_logic;
			ar_clk : out  std_logic;
			dm_ctrl : out  std_logic;
			opcode : in  std_logic_vector (15 DOWNTO 0);
			dm_rd : in  std_logic_vector (15 DOWNTO 0);
			dm_wr : out  std_logic_vector (15 DOWNTO 0);
			code_adr : out  std_logic_vector (9 DOWNTO 0);
			data_adr : out  std_logic_vector (15 DOWNTO 0);
			reset : in  std_logic
		);
	END COMPONENT;

	SIGNAL clock : std_logic;
	SIGNAL opc_clk : std_logic;
	SIGNAL ar_clk : std_logic;
	SIGNAL dm_ctrl : std_logic;
	SIGNAL opcode : std_logic_vector (15 DOWNTO 0);
	SIGNAL dm_rd : std_logic_vector (15 DOWNTO 0);
	SIGNAL dm_wr : std_logic_vector (15 DOWNTO 0);
	SIGNAL code_adr : std_logic_vector (9 DOWNTO 0);
	SIGNAL data_adr : std_logic_vector (15 DOWNTO 0);
	SIGNAL reset : std_logic;

BEGIN
	UUT : CPU
	PORT MAP (
		clock => clock,
		opc_clk => opc_clk,
		ar_clk => ar_clk,
		dm_ctrl => dm_ctrl,
		opcode => opcode,
		dm_rd => dm_rd,
		dm_wr => dm_wr,
		code_adr => code_adr,
		data_adr => data_adr,
		reset => reset
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_opc_clk(
			next_opc_clk : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (opc_clk /= next_opc_clk) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns opc_clk="));
				write(TX_LOC, opc_clk);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_opc_clk);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_ar_clk(
			next_ar_clk : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (ar_clk /= next_ar_clk) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns ar_clk="));
				write(TX_LOC, ar_clk);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_ar_clk);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_dm_ctrl(
			next_dm_ctrl : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (dm_ctrl /= next_dm_ctrl) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns dm_ctrl="));
				write(TX_LOC, dm_ctrl);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_dm_ctrl);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_dm_wr(
			next_dm_wr : std_logic_vector (15 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (dm_wr /= next_dm_wr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns dm_wr="));
				write(TX_LOC, dm_wr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_dm_wr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_code_adr(
			next_code_adr : std_logic_vector (9 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (code_adr /= next_code_adr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns code_adr="));
				write(TX_LOC, code_adr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_code_adr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_data_adr(
			next_data_adr : std_logic_vector (15 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (data_adr /= next_data_adr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns data_adr="));
				write(TX_LOC, data_adr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_data_adr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clock <= transport '0';
		opcode <= transport std_logic_vector'("0000000000000000"); --0
		dm_rd <= transport std_logic_vector'("0000000000000000"); --0
		reset <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=5 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=10 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=45 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=80 ns
		reset <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=85 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=90 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=125 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=160 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=165 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=170 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=205 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=240 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=245 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=250 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=285 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=320 ns
		opcode <= transport std_logic_vector'("0001000100110100"); --1134
		-- --------------------
		WAIT FOR 5 ns; -- Time=325 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=330 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=365 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=400 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=405 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=410 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=445 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=480 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=485 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=490 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=525 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=560 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=565 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=570 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=605 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=640 ns
		opcode <= transport std_logic_vector'("0001010100010010"); --1512
		-- --------------------
		WAIT FOR 5 ns; -- Time=645 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=650 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=685 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=720 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=725 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=730 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=765 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=800 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=805 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=810 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=845 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=880 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=885 ns
		clock <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=890 ns
		-- --------------------
		WAIT FOR 35 ns; -- Time=925 ns
		clock <= transport '0';
		-- --------------------
		WAIT FOR 35 ns; -- Time=960 ns
		opcode <= transport std_logic_vector'("0001000000000000"); --1000
		-- --------------------
		WAIT FOR 5 ns; -- Time=965 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION CPU_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END CPU_cfg;
